/* 
 * File:   ClipperMap.h
 * Author: tg
 *
 * Created on July 19, 2012, 11:32 AM
 */

#ifndef CLIPPERMAP_H
#define	CLIPPERMAP_H

#include "Reflex.h"
#include <vector>

#include <clipper/clipper.h>

class ClipperMap {
private:
    clipper::Spacegroup sg_;
    clipper::Cell cell_;
    double dhighres_;
    clipper::HKL_info hklinfo_;
    clipper::HKL_data<clipper::data64::F_phi> hkldataFphi_;
    clipper::Xmap<float> map_;
public:
    ClipperMap(const std::vector<Reflex>& reflections, 
            const clipper::Spacegroup& sg,
            const clipper::Cell& cell,
            double dhighres);

    ~ClipperMap() {}
    
    /* ask clipper to create clipper Xmap from data */
    void makeMap();
    /* write map to an map in ccp4 format */
    void writeCCP4map (const char* filename) const;

};

#endif	/* CLIPPERMAP_H */

