/* 
 * File:   conversions.h
 * Author: tg
 *
 * Created on July 19, 2012, 1:30 PM
 */

#ifndef CONVERSIONS_H
#define	CONVERSIONS_H

#include "Vec3.h"
#include <vector>
#include <string>
#include <clipper/clipper.h>

std::string mapfilename (const std::string& inputfn,
        const std::string& ext = ".map");

clipper::Spacegroup clipperSG (const std::vector<std::string>& symopsStrings);
clipper::Cell       clipperCell (float a, float b, float c,
        float alpha, float beta, float gamma);

void syminfoFromPDB (const std::string& pdbfile, 
        clipper::Spacegroup& sg, 
        clipper::Cell& cell);

void cellVectors (const double a, const double b, const double c,
        const double alpa, const double beta, const double gamma,
        Vec3& avec, Vec3& bvec, Vec3& cvec);

void recCell (const Vec3& a, const Vec3& b, const Vec3& c,
        Vec3& astar, Vec3& bstar, Vec3& cstar);

#endif	/* CONVERSIONS_H */

