/* 
 * File:   mapcoeffile.h
 * Author: tg
 *
 * Created on June 28, 2012, 10:28 PM
 */

#ifndef MAPCOEFFILE_H
#define	MAPCOEFFILE_H

#include "Reflex.h"

#include <vector>
#include <string>

/** 
 * base class for map coefficients
 * - could be fcf (at stage of writing: presumably F^2_meas,
 * F^2_sigma, F_calc
 * - or phs (h k l F fom phi sigF)
 */
class mapcoeffile {
private:
    std::string filename_;
protected:
    std::vector<Reflex> reflections_;
    void filename (const std::string& fn) { filename_ = fn; }
public:
    mapcoeffile(const char* filename): filename_(filename) {}
    
    virtual std::vector<Reflex> reflections() const { return reflections_; }
    
    std::string filename() const { return filename_; }

};

#endif	/* MAPCOEFFILE_H */

