#include "usage.h"

#include <iostream>
#include <iomanip>

void usage() {
    std::cout 
            << std::setfill('*')
            << std::setw(80)
            << "*\n"
            << std::setfill (' ')
            << std::setw(78) << std::left
            << "* shelx2map - convert shelx .fcf and .phs files to"
            << "*\n"
            << std::setw(78) << std::left
            << "*             to ccp4-format for use in e.g. pymol."
            << "*\n"
            << std::setw(78) << std::left
            << "* (c) Tim Gruene, 7/2012"
            << "*\n"
            << std::right
            << std::setfill('*')
            << std::setw(80)
            << "*\n";
            
    std::cout 
            << "Usage: shelx2map [OPTIONS] inputfile[.fcf] [fa_file]\n"
            << "       inputfile:   fcf-file (LIST 6 only) with or without suffix\n"
            << "       fa_file:     use Fa and phi = phicalc - alpha for \n"
            << "                    creating an anomalous map\n"
            << "       -o filename: explicitly sets output filename\n"
            << "                    unset: derived from input filename + '.map'\n"
            << "       -m N:        integer weight for fcf-files:\n"
            << "                    m=0: |Fo|-|Fc| map\n"
            << "                    m>0: m|Fo| - (m-1)|Fc| map\n"
            << "                    unset: create both difference map and 3|Fo| - 2|Fc| map\n"
            << "       -w w      :  downweight weak data with Fc^4/(Fc^4+w*sig(Fo)**4)\n"
            << "                    without '-w', weighting with w=1.0 is applied.\n";
    
    std::cout << "\n"
            << "   or: shelx2map [OPTIONS] inputfile[.phs]\n"
            << "       inputfile  : phs-file with or without suffix\n"
            << "       -o mapname : explicitly sets output filename\n"
            << "                    unset: derived from input filename + '.map'\n"
            << "       -s pdbfile : MANDATORY: source of spacegroup and cell from CRYST1\n"
            << "       -f         : Do NOT weight F with FOM\n"
            << "       -w w       : downweight weak data with 1/(1+w*(sig(Fo)/F)**4)\n"
            << "                    implies '-f', i.e. FOM is not applied\n"
            << "       -h /-?:      print this help message\n";
}
